<?php
/***************************************************************************
                             digest_upgrade_db.php
                             ---------------------
    begin                : Wed Mar 7 2007
    copyright            : (c) Mark D. Hamill
    email                : mhamill@computer.org

    $Id: $

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

// Written by Mark D. Hamill, mhamill@computer.org
// This software is designed to work with phpBB Version 2.0.22

// This program is run only if you upgrading from version 1.0.16 or earlier. It needs to be run BEFORE installing the other files.

define('IN_PHPBB', true);
$phpbb_root_path = '../';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/digest_constants.' . $phpEx); 

define('DIGEST_SETTINGS_TABLE', $table_prefix.'mod_digest_settings');

// Check the version number

if ($settings['version'] == '')
{
	// Assume this is the first official phpBB release, 1.0.9b
	$major_version = 1;
	$minor_version = 0;
	$micro_version = 9;
}
else // The constant showed up starting in version 1.0.10
{
	$version= explode(".",DIGEST_VERSION);
	$major_version = $version[0];
	$minor_version = $version[1];
	$micro_version = $version[2];
}

if (($major_version == 1) && ($minor_version == 0) && ($micro_version < 13))
{
	// If DBMS is MySQL, add PHTM as an enumerated data type
	if (($dbms == 'mysql') || ($dbms == 'mysql4'))
	{
		$sql = 'ALTER TABLE ' . DIGEST_SUBSCRIPTIONS_TABLE . " CHANGE format ENUM('HTML', 'PHTM', 'TEXT') DEFAULT 'HTML'";
		if ( !($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Error altering ' . DIGEST_SUBSCRIPTIONS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
		}
	}
}

if (($major_version == 1) && ($minor_version == 0) && ($micro_version < 17))
{
	// 1.0.17 add show_pms column. With the DEFAULT syntax, all existing rows *should* show this value
	$sql = 'ALTER TABLE ' . DIGEST_SUBSCRIPTIONS_TABLE . " ADD show_pms CHAR(3) NOT NULL DEFAULT 'YES'";
	if ( !($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Error altering ' . DIGEST_SUBSCRIPTIONS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
	}

	// Assume everyone would like private messages in the digest
	$sql = 'UPDATE ' . DIGEST_SUBSCRIPTIONS_TABLE . " SET show_pms = 'YES'";
	if ( !($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Error updating ' . DIGEST_SUBSCRIPTIONS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
	}

	// create the settings table
	$sql='CREATE TABLE ' . DIGEST_SETTINGS_TABLE . " (
	  table_key int(11) NOT NULL,
	  version varchar(10) NOT NULL default '1.0.17',
	  site_url varchar(255) NOT NULL default 'http://www.example.com/phpBB/',
	  autosubscribe_users char(3) NOT NULL default 'NO',
	  autosubscribe_daily varchar(4) NOT NULL default 'DAY',
	  weekly_digest_day int(11) NOT NULL default '0',
	  use_custom_stylesheet char(3) NOT NULL default 'NO',
	  custom_stylesheet_path varchar(255) NOT NULL default 'templates/subSilver/digest_stylesheet.css',
	  date_format varchar(20) NOT NULL default 'd M Y h:i A',
	  server_display_date varchar(20) NOT NULL default 'm/d/Y',
	  html_encoding varchar(20) NOT NULL default 'iso-8859-1',
	  text_encoding varchar(20) NOT NULL default 'us-ascii',
	  show_summary char(3) NOT NULL default 'YES',
	  summary_type varchar(4) NOT NULL default 'HTML',
	  require_send_key char(3) NOT NULL default 'NO',
	  send_key varchar(255) NOT NULL default 'qwertyuiop',
	  users_per_page int(11) NOT NULL default '20',
	  mail_digests_phpbb_path varchar(255) NOT NULL default './',
	  PRIMARY KEY  (table_key)
	) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Digest Settings Table' AUTO_INCREMENT=1";

	if ( !($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Unable to create '. DIGEST_SETTINGS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
	}

	// Insert the one row required in the digest settings table
	$sql = 'INSERT INTO ' . DIGEST_SETTINGS_TABLE . ' (table_key) VALUES (1)'; 
	if ( !($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Unable to insert row into '. DIGEST_SETTINGS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
	}

}

?>
<html>
<head>
<title>Digest Upgrade Database</title>
</head>
<body> 
<p>If you see this message, then your database should be upgraded to support the latest digest features.</p> 
<?php
if (($major_version == 1) && ($minor_version == 0) && ($micro_version < 17))
{
	echo '<p>Please note that if you want users who have thus far not chosen to receive a digest to now automatically receive one, you should run the program ' . DIGEST_SITE_URL . '/install/digest_subscribe_all.php now.</p>.';
}
?> 
<p>If you are all done, please delete this file and remove the install directory, since your forum will not be accessible until it is removed.</p> 
</body>
</html>
